import direct.directbase.DirectStart
from pandac.PandaModules import *
from direct.gui.DirectGui import *
from direct.interval.IntervalGlobal import *
from direct.actor import Actor
from direct.task import Task 
import sys, os, time, math

import picker 

class Interface(DirectObject):
    
  def __init__(self, parent):
       
    # setup the picker for mouse clicks on interface 
    self.pick = picker.Picker()
       
    #Load the interface
    self.interface = loader.loadModel('models/interface')
    self.interface.setPosHprScale(-2.5,0,3,0,0,0,.15,.15,.15)
    self.interface.reparentTo(parent)
    
    # find the buttons in the interface
    ## self.buttons[i] = self.buttonLoad( 'button' + str(i+1), render)
    self.happyButton = self.buttonLoad( 'HappyButton', self.interface, parent)
    self.worryButton = self.buttonLoad( 'WorryButton', self.interface, parent)
    self.madButton = self.buttonLoad( 'MadButton', self.interface, parent)
    self.surprisedButton = self.buttonLoad( 'SupprisedButton', self.interface, parent)
    self.sadButton = self.buttonLoad( 'SadButton', self.interface, parent)
    self.sleepyButton = self.buttonLoad( 'SleepyButton', self.interface, parent)
    self.neutralButton = self.buttonLoad( 'NButton', self.interface, parent)
    self.Ev1Button = self.buttonLoad( 'Ev1CharlieButton', self.interface, parent)
    self.Ev2Button = self.buttonLoad( 'Ev2CharlieButton', self.interface, parent)
    self.Ev3Button = self.buttonLoad( 'Ev3CharlieButton', self.interface, parent)
    self.Ev4Button = self.buttonLoad( 'Ev4CharlieButton', self.interface, parent)
    ## self.rightEyeBall = self.buttonLoad( 'RightEyeball', self.interface, parent)
    ## self.leftEyeBall = self.buttonLoad( 'LeftEyeball', self.interface, parent)
    self.micUpButton = self.buttonLoad( 'MicUpButton', self.interface, parent)
    self.micDownButton = self.buttonLoad( 'MicDownButton', self.interface, parent)
    
    # clean up unused buttons - please fix model
    self.sleepButton = self.buttonLoad( 'SleepButton', self.interface, parent)
    self.sleepButton.hide()
    self.sleepButtonborder = self.buttonLoad( 'SleepButtonborder', self.interface, parent)
    self.sleepButtonborder.hide()
    self.wakeupButton = self.buttonLoad( 'WakeupButton', self.interface, parent)
    self.wakeupButton.hide()
    self.wakeupButtonborder = self.buttonLoad( 'WakeupButtonborder', self.interface, parent)
    self.wakeupButtonborder.hide()
    
    # find the selection panels
    self.neutralSelection = self.interface.find( '**/NSelection' )
    self.happyEmoteSelection = self.interface.find( '**/HappyEmoteSelection' )
    self.worryEmoteSelection = self.interface.find( '**/WorryEmoteSelection' )
    self.madEmoteSelection = self.interface.find( '**/MadEmoteSelection' )
    self.surprisedEmoteSelection = self.interface.find( '**/SuprisedEmoteSelection' )
    self.sadEmoteSelection = self.interface.find( '**/SadEmoteSelection' )
    self.sleepyEmoteSelection = self.interface.find( '**/SleepyEmoteSelection' )
    self.hideEmotes()
    self.neutralSelection.show()
    
    #Load the interface eyes
    self.EyeBalls = loader.loadModel('models/interfaceEye')
    self.EyeBalls.setPosHprScale(-2.5,0,3,0,0,0,.15,.15,.15)
    self.EyeBalls.reparentTo(parent)
    self.rightEyeBall = self.buttonLoad( 'RightEyeball', self.EyeBalls, parent)
    self.rightEyeBall.setPosHpr(16.5,0,17,0,0,0)
    self.leftEyeBall = self.buttonLoad( 'LeftEyeball', self.EyeBalls, parent)
    self.leftEyeBall.setPosHpr(26.5,0,17,0,0,0)
    
    # define an event handler for when buttons are picked
    self.accept("objectPicked", self.buttonPicked )
    
    # check out the render queue - comment out later
    ## print render.ls()
        
      
    ## self.accept( ".", self.teststuff, [ -1 ] )   #### comment out later
    ## self.accept( "/", self.teststuff, [ 1 ] )    #### comment out later
    ## self.accept( "k", self.teststuff2, [ VBase3( 0, -.01, 0) ] )   #### comment out later
    ## self.accept( "j", self.teststuff2, [ VBase3( 0, .01, 0) ] )    #### comment out later
    
 
#################Interface buttons###########################################

  def buttonLoad(self, piece, fromObj, parent):
    # return a button object
    ## object = self.interface.find( '**/' + piece )
    object = fromObj.find( '**/' + piece )
    object.reparentTo(parent)
    ## object.setPosHprScale(self.interface.getPosHprScale())
    object.setPosHprScale(-2.5,0,3,0,0,0,.15,.15,.15)
    # assign this object as an object that can be picked by the mouse
    self.pick.makePickable(object)
    return object

  def buttonPicked(self):
    # Do something based on which button was picked.

    button = self.pick.getPickedObj()
    print button
    if (str(button) == 'render/puppetSee/HappyButton'):
        print 'got HappyButton'
        ## self.facePoseHappy()
        messenger.send('gotHappyButton') 
        self.hideEmotes()
        self.happyEmoteSelection.show() 
    elif (str(button) == 'render/puppetSee/WorryButton'):
        print 'got WorryButton'
        ## self.facePoseWorried()
        messenger.send('gotWorryButton')
        self.hideEmotes()
        self.worryEmoteSelection.show() 
    elif (str(button) == 'render/puppetSee/MadButton'):
        print 'got MadButton'
        ## self.facePoseMad()
        messenger.send('gotMadButton')
        self.hideEmotes()
        self.madEmoteSelection.show() 
    elif (str(button) == 'render/puppetSee/SupprisedButton'):
        print 'got SurprisedButton'
        ## self.facePoseSurprised()
        messenger.send('gotSurprisedButton')
        self.hideEmotes()
        self.surprisedEmoteSelection.show() 
    elif (str(button) == 'render/puppetSee/SadButton'):
        print 'got SadButton'
        ## self.facePoseSad()
        messenger.send('gotSadButton')
        self.hideEmotes()
        self.sadEmoteSelection.show()
    elif (str(button) == 'render/puppetSee/SleepyButton'):
        print 'got SleepyButton'
        ## self.facePoseSleepy()
        messenger.send('gotSleepyButton')
        self.hideEmotes()
        self.sleepyEmoteSelection.show()
    elif (str(button) == 'render/puppetSee/SleepButton'):
        print 'got SleepButton'
        ## self.faceGotoSleep()
        ## messenger.send('gotSleepButton')
    elif (str(button) == 'render/puppetSee/WakeupButton'):
        print 'got WakeupButton'
        ## self.faceWakeup()
        ## messenger.send('gotWakeupButton')
    elif (str(button) == 'render/puppetSee/NButton'):
        print 'got NButton'
        ## self.facePoseN()
        messenger.send('gotNButton')
        self.hideEmotes()
        self.neutralSelection.show()
    elif (str(button) == 'render/puppetSee/Ev1CharlieButton'):
        print 'got Ev1CharlieButton'
        ## self.charlieEv1()
        messenger.send('gotEv1CharlieButton')
    elif (str(button) == 'render/puppetSee/Ev2CharlieButton'):
        print 'got Ev2CharlieButton'
        ## self.charlieEv2()
        messenger.send('gotEv2CharlieButton')
    elif (str(button) == 'render/puppetSee/Ev3CharlieButton'):
        print 'got Ev3CharlieButton'
        ## self.charlieEv3()
        messenger.send('gotEv3CharlieButton')
    elif (str(button) == 'render/puppetSee/Ev4CharlieButton'):
        print 'got Ev4CharlieButton'
        ## self.charlieEv4()
        messenger.send('gotEv4CharlieButton')
    elif (str(button) == 'render/puppetSee/RightEyeball'):
        print 'got RightEyeball'
        ## self.moveEyes()
        messenger.send('gotMoveEyes')
    elif (str(button) == 'render/puppetSee/LeftEyeball'):
        print 'got LeftEyeball'
        ## self.moveEyes()
        messenger.send('gotMoveEyes')
    elif (str(button) == 'render/puppetSee/MicUpButton'):
        print 'got MicUpButton'
        ## self.changeSensibility( 0.02  )   # increase sensibility
        messenger.send('gotMicUpButton')
    elif (str(button) == 'render/puppetSee/MicDownButton'):
        print 'got MicDownButton'
        ## self.changeSensibility( -0.02  )  # lower sensibility
        messenger.send('gotMicDownButton')
     

###################Interface Functions#######################################

  def moveIntEyes(self, amountX, amountY):
    # rotate the interface's eyes
    self.rightEyeBall.setH(amountX)
    self.leftEyeBall.setH(amountX)
    self.rightEyeBall.setP(amountY)
    self.leftEyeBall.setP(amountY)
    
  def resetIntEyes(self):
    # rotate the interface's eyes
    self.rightEyeBall.setH(0)
    self.leftEyeBall.setH(0)
    self.rightEyeBall.setP(0)
    self.leftEyeBall.setP(0)
    
  def hideEmotes(self):
    self.neutralSelection.hide()
    self.happyEmoteSelection.hide()
    self.worryEmoteSelection.hide()
    self.madEmoteSelection.hide()
    self.surprisedEmoteSelection.hide()
    self.sadEmoteSelection.hide()
    self.sleepyEmoteSelection.hide()
    
  def fadeOutEye(self):
    alphaInterval = LerpFunctionInterval(self.rightEyeBall.setAlphaScale, toData = 0.0, fromData = 1.0, duration = 1.2)
    alphaInterval.start()
    print "in fade out I"