## import direct.directbase.DirectStart           # needed to start panda
## from pandac.PandaModules import *              # needed to start panda

## from direct.gui.DirectGui import *             # needed for on screen text
## from direct.showbase.DirectObject import DirectObject  # needed for event handling

from direct.task import Task                   # needed for tasks

## from direct.actor import Actor                 # needed to load animated models
## from direct.interval.IntervalGlobal import *   # needed for animation sequencing

## import math                                    # needed for math functions
## import sys                                     # needed for sys.exit

## from pygame import *
import pygame 
## import pygame.base as pybase
pygame.init()

#############################################################################
#############################################################################

## class Joy(DirectObject): 
class Joy:                        # class object define
                                               # if no event handling then DirectObject is not needed
  def __init__(self, events):                          # Initialize the class

    self.events = events
    #Setup and init joystick
    self.j=pygame.joystick.Joystick(0)
    self.j.init()

    #Check init status
    if self.j.get_init() == 1: print "Joystick is initialized"

    #Get and print joystick ID
    print "Joystick ID: ", self.j.get_id()

    #Get and print joystick name
    print "Joystick Name: ", self.j.get_name()

    #Get and print number of axes
    print "No. of axes: ", self.j.get_numaxes()

    #Get and print number of trackballs
    print "No. of trackballs: ", self.j.get_numballs()

    #Get and print number of buttons
    print "No. of buttons: ", self.j.get_numbuttons()

    #Get and print number of hat controls
    print "No. of hat controls: ", self.j.get_numhats()

    #Add the task to search the event queue for button evens
    taskMgr.add(self.pollButtonsTask,"joystickPollButtonsTask")
    
    #Setup event information and print data from joystick
    ## while 1:
        ## for e in event.get():
            ## if e.type != pygame.QUIT:
                ## ## print '%s: %s' % (pygame.event.event_name(e.type), e.dict)
                ## if e.type == pygame.JOYAXISMOTION:
                    ## # have a movement on the stick
                ## elif e.type == pygame.JOYBALLMOTION:
                    ## # have a movement on the trackball
                ## elif e.tpye == pygame.JOYHATMOTION:
                    ## # have a movement on the hat
                ## elif e.type == pygame.JOYBUTTONDOWN:
                    ## # a button has been pressed
                ## elif e.type == pygame.JOYBUTTONUP:
                    ## # a button has been released
 
 #############################################################################
  
  def pollButtonsTask(self,task):
    for event in pygame.event.get():
        if (event.type in (pygame.JOYBUTTONUP,pygame.JOYBUTTONDOWN)) :
            self.sendButtonEvent(event.button,event.type==pygame.JOYBUTTONUP)
        if (event.type == pygame.JOYHATMOTION ) :
            self.sendHatEvent(event.value)
    return Task.cont              

#############################################################################

#############################################################################

  def sendButtonEvent(self,button,up=False):
    if (button in self.events):
        messenger.send(self.events[button]+(up and "-up" or "-down"))
            
#############################################################################

#############################################################################

  def sendHatEvent(self, position):
    messenger.send("hatevent")
            
#############################################################################

#############################################################################

  def getAxis(self,axis,invert = False):
    if (invert):
        return (self.j.get_axis(axis) * -1)
    else:
        return self.j.get_axis(axis)
            
#############################################################################

#############################################################################

  def getHat(self,hat):
    return self.j.get_hat(hat)
            
#############################################################################

#############################################################################

  def clearQueue(self):
       # clear out the event queue
       pygame.event.clear()

#############################################################################

#############################################################################

  def quitJoy(self):
       # uninitialize the joystick module and clear out the event queue
       ## self.clearQueue()
       print 'in'
       self.j.quit()
       
#############################################################################

#############################################################################

  def getEvents(self):
       # return the event queue
       return pygame.event.get()

#############################################################################

#############################################################################

  def getEventName(self,type):
       # return the event queue
       return pygame.event.event_name(type)

#############################################################################
#############################################################################
